﻿using AutoMapper;
using DeepCopy.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace DeepCopy.Controllers
{
    public class ExampleController : ApiController
    {
        public List<Person> Get()
        {
            //define our original person object
            var originalPerson = new Person()
            {
                FirstName = "Jasper",
                LastName = "Showers",
            };

            //ideally this would be done in a config file at app startup
            Mapper.Initialize(cfg => cfg.CreateMap<Person, Person>());

            //create the deep copy using AutoMapper
            var deepCopy = Mapper.Map<Person>(originalPerson);

            //change properties on the original
            originalPerson.FirstName = "Ronald";
            originalPerson.LastName = "McDonald";

            //record any property changes for the two objects
            //leaving this part out for the sake of the example and return both objects
            return new List<Person>()
            {
                originalPerson,
                deepCopy,
            };
        }
    }
}
